#include <QTime>
#include <QDebug>
#include "Map.h"

CMap  map;

//---------------------------------------------------------------------------------------------
CWall::CWall()
{
    mType = 0;
}

//---------------------------------------------------------------------------------------------
CTile::CTile()
{
    mType = 0;
}

//---------------------------------------------------------------------------------------------
CMap::CMap()
{
    // default values
    mSize = CVec2(15, 10);
    mTiles = NULL;
}

//---------------------------------------------------------------------------------------------
CMap::~CMap()
{
    if (mTiles != NULL)
        delete[] mTiles;
}

//---------------------------------------------------------------------------------------------
void CMap::resize()
{
    if (mTiles != NULL)
        delete[] mTiles;

    mTiles = new CTile[mSize.x * mSize.y];
}

//---------------------------------------------------------------------------------------------
void   CMap::setTile(CVec2 pos, uint8_t type)
{
    if (pos.x >= 0 && pos.x < mSize.x &&
        pos.y >= 0 && pos.y < mSize.y)
    {
        getTile(pos)->mType = type;
    }
}

//---------------------------------------------------------------------------------------------
void   CMap::setWall(CVec2 pos, EWallSide side, uint8_t type)
{
    if (pos.x >= 0 && pos.x < mSize.x &&
        pos.y >= 0 && pos.y < mSize.y)
    {
        getTile(pos)->mWalls[side].mType = type;
    }
}

//---------------------------------------------------------------------------------------------
CTile*  CMap::getTile(CVec2 pos)
{
    if (pos.x < 0 || pos.x >= mSize.x ||
        pos.y < 0 || pos.y >= mSize.y)
        return NULL;

    return(&mTiles[pos.y * mSize.x + pos.x]);
}

//---------------------------------------------------------------------------------------------
bool CMap::isLoaded()
{
    return mTiles != NULL;
}
